it-swarm.com.ru

Как проверить, установлена ​​ли переменная в Bash?

Как узнать, установлена ​​ли переменная в Bash?

Например, как я могу проверить, передал ли пользователь первый параметр функции?

function a {
    # if $1 is set ?
}
1290
prosseek

(Обычно) правильный путь

if [ -z ${var+x} ]; then echo "var is unset"; else echo "var is set to '$var'"; fi

где ${var+x} - это расширение параметра , которое равно нулю, если var не установлено, и подставляет строку x в противном случае.

Цитаты Отступление

Кавычки могут быть опущены (поэтому мы можем сказать ${var+x} вместо "${var+x}"), потому что этот синтаксис и использование гарантируют, что это будет расширяться только до чего-то, что не требует кавычек (так как оно либо расширяется до x (который не содержит разрывов Word, поэтому не нуждается в кавычках) или к нулю (что приводит к [ -z ], который удобно вычисляет то же значение (true), что и [ -z "" ] также)).

Однако, хотя кавычки могут быть безопасно опущены, и это было не сразу очевидно для всех (это даже не было очевидно первый автор этого объяснения цитат кто также является основным Bash-кодером), это будет иногда лучше написать решение с кавычками в виде [ -z "${var+x}" ] при очень небольшой возможной стоимости O(1) штрафа за скорость. Первый автор также добавил это в качестве комментария рядом с кодом, использующим это решение, предоставив URL-адрес для этого ответа, который теперь также включает в себя объяснение того, почему кавычки можно безопасно опускать.

(Часто) Неправильный путь

if [ -z "$var" ]; then echo "var is blank"; else echo "var is set to '$var'"; fi

Это часто неправильно, поскольку не различает переменную, которая не установлена, и переменную, для которой задана пустая строка. То есть, если var='', то вышеприведенное решение выведет "var is blank".

Различие между unset и "set to empty string" является существенным в ситуациях, когда пользователь должен указать расширение или дополнительный список свойств, и если не указывать их, по умолчанию используется непустое значение, тогда как указание пустой строки должно заставить скрипт использовать пустое расширение или список дополнительных свойств.

Различие не может быть существенным в каждом сценарии все же. В этих случаях [ -z "$var" ] будет просто отлично.

1936
Lionel

Чтобы проверить наличие ненулевой/ненулевой строковой переменной, т.е. если она установлена, используйте

if [ -n "$1" ]

Это противоположность -z. Я использую -n больше, чем -z.

Вы бы использовали это как:

if [ -n "$1" ]; then
  echo "You supplied the first parameter!"
else
  echo "First parameter not supplied."
fi
763
mbrannig

Вот как проверить, является ли параметр неустановленным или пустым ("Нулевым") или установить со значением :

+--------------------+----------------------+-----------------+-----------------+
|                    |       parameter      |     parameter   |    parameter    |
|                    |   Set and Not Null   |   Set But Null  |      Unset      |
+--------------------+----------------------+-----------------+-----------------+
| ${parameter:-Word} | substitute parameter | substitute Word | substitute Word |
| ${parameter-Word}  | substitute parameter | substitute null | substitute Word |
| ${parameter:=Word} | substitute parameter | assign Word     | assign Word     |
| ${parameter=Word}  | substitute parameter | substitute null | assign Word     |
| ${parameter:?word} | substitute parameter | error, exit     | error, exit     |
| ${parameter?word}  | substitute parameter | substitute null | error, exit     |
| ${parameter:+Word} | substitute Word      | substitute null | substitute null |
| ${parameter+Word}  | substitute Word      | substitute Word | substitute null |
+--------------------+----------------------+-----------------+-----------------+

Источник: POSIX: расширение параметров :

Во всех случаях, показанных с "заменой", выражение заменяется показанным значением. Во всех случаях, показанных с помощью "assign", параметру присваивается это значение, которое также заменяет выражение.

422
Jens

Хотя большинство методов, изложенных здесь, верны, bash 4.2 поддерживает фактический тест на наличие переменной ( man bash ), а не тестирование значения переменной.

[[ -v foo ]]; echo $?
# 1

foo=bar
[[ -v foo ]]; echo $?
# 0

foo=""
[[ -v foo ]]; echo $?
# 0

Примечательно, что этот подход не вызовет ошибку при использовании для проверки неустановленной переменной в режиме set -u/set -o nounset, в отличие от многих других подходов, таких как использование [ -z.

193
Russell Harmon

Есть много способов сделать это, одним из которых является следующее:

if [ -z "$1" ]

Это успешно, если $ 1 ноль или не установлен

173
ennuikiller

Чтобы увидеть, является ли переменная непустой, я использую

if [[ $var ]]; then ...       # `$var' expands to a nonempty string

Противоположные тесты, если переменная не установлена ​​или пуста:

if [[ ! $var ]]; then ...     # `$var' expands to the empty string (set or not)

Чтобы увидеть, установлена ​​ли переменная (пустая или непустая), я использую

if [[ ${var+x} ]]; then ...   # `var' exists (empty or nonempty)
if [[ ${1+x} ]]; then ...     # Parameter 1 exists (empty or nonempty)

Противоположные тесты, если переменная не установлена:

if [[ ! ${var+x} ]]; then ... # `var' is not set at all
if [[ ! ${1+x} ]]; then ...   # We were called with no arguments
62
phkoester

Я всегда нахожу таблицу POSIX в другой ответ медленно, чтобы грок, поэтому вот мой взгляд на это:

   +----------------------+------------+-----------------------+-----------------------+
   |   if VARIABLE is:    |    set     |         empty         |        unset          |
   +----------------------+------------+-----------------------+-----------------------+
 - |  ${VARIABLE-default} | $VARIABLE  |          ""           |       "default"       |
 = |  ${VARIABLE=default} | $VARIABLE  |          ""           | $(VARIABLE="default") |
 ? |  ${VARIABLE?default} | $VARIABLE  |          ""           |       exit 127        |
 + |  ${VARIABLE+default} | "default"  |       "default"       |          ""           |
   +----------------------+------------+-----------------------+-----------------------+
:- | ${VARIABLE:-default} | $VARIABLE  |       "default"       |       "default"       |
:= | ${VARIABLE:=default} | $VARIABLE  | $(VARIABLE="default") | $(VARIABLE="default") |
:? | ${VARIABLE:?default} | $VARIABLE  |       exit 127        |       exit 127        |
:+ | ${VARIABLE:+default} | "default"  |          ""           |          ""           |
   +----------------------+------------+-----------------------+-----------------------+

Обратите внимание, что каждая группа (с и без предшествующего двоеточия) имеет одинаковые случаи set ​​и nset, поэтому отличается только то, как empty дела обрабатываются.

С предыдущим двоеточием случаи empty и nset ​​идентичны, поэтому я бы использовал их, где это возможно (т. Е. Используйте :=, а не просто =, поскольку пустой регистр несовместим) ,.

Заголовки:

  • set ​​означает, что VARIABLE не пусто (VARIABLE="something")
  • пусто означает, что VARIABLE пуст/null (VARIABLE="")
  • nset ​​означает, что VARIABLE не существует (unset VARIABLE)

Значения:

  • $VARIABLE означает, что результатом является исходное значение переменной.
  • "default" означает, что результатом была предоставленная строка замены.
  • "" означает, что результат равен нулю (пустая строка).
  • exit 127 означает, что скрипт прекращает выполнение с кодом завершения 127.
  • $(VARIABLE="default") означает, что результатом является исходное значение переменной и предоставленная строка замены присваивается переменной для будущего использования.
55
deizel

В современной версии Bash (4.2 или более поздней версии, я думаю, я точно не знаю) я бы попробовал это:

if [ ! -v SOMEVARIABLE ] #note the lack of a $ sigil
then
    echo "Variable is unset"
Elif [ -z "$SOMEVARIABLE" ]
then
    echo "Variable is set to an empty string"
else
    echo "Variable is set to some string"
fi
31
Seamus Connor
if [ "$1" != "" ]; then
  echo \$1 is set
else
  echo \$1 is not set
fi

Хотя для аргументов обычно лучше всего проверить $ #, что, по моему мнению, является количеством аргументов.

if [ $# -gt 0 ]; then
  echo \$1 is set
else
  echo \$1 is not set
fi
19
Paul Creasey

Вы хотите выйти, если он не установлен

Это сработало для меня. Я хотел, чтобы мой скрипт завершал работу с сообщением об ошибке, если параметр не был установлен.

#!/usr/bin/env bash

set -o errexit

# Get the value and empty validation check all in one
VER="${1:?You must pass a version of the format 0.0.0 as the only argument}"

Возвращается с ошибкой при запуске

[email protected]:~$ ./setver.sh
./setver.sh: line 13: 1: You must pass a version of the format 0.0.0 as the only argument

Только проверка, нет выхода - пусто и неустановлено недействительно

Попробуйте эту опцию, если вы просто хотите проверить, установлено ли значение set = VALID или unset/empty = INVALID.

TSET="good val"
TEMPTY=""
unset TUNSET

if [ "${TSET:-}" ]; then echo "VALID"; else echo "INVALID";fi
# VALID
if [ "${TEMPTY:-}" ]; then echo "VALID"; else echo "INVALID";fi
# INVALID
if [ "${TUNSET:-}" ]; then echo "VALID"; else echo "INVALID";fi
# INVALID

Или даже короткие тесты ;-)

[ "${TSET:-}"   ] && echo "VALID" || echo "INVALID"
[ "${TEMPTY:-}" ] && echo "VALID" || echo "INVALID"
[ "${TUNSET:-}" ] && echo "VALID" || echo "INVALID"

Только проверка, нет выхода - только пусто - НЕВЕРНО

И это ответ на вопрос. Используйте это, если вы просто хотите проверить, установлено ли значение set/empty = VALID или unset = INVALID.

ПРИМЕЧАНИЕ: "1" в "..- 1}" не имеет значения, это может быть что угодно (например, x)

TSET="good val"
TEMPTY=""
unset TUNSET

if [ "${TSET+1}" ]; then echo "VALID"; else echo "INVALID";fi
# VALID
if [ "${TEMPTY+1}" ]; then echo "VALID"; else echo "INVALID";fi
# VALID
if [ "${TUNSET+1}" ]; then echo "VALID"; else echo "INVALID";fi
# INVALID

Короткие тесты

[ "${TSET+1}"   ] && echo "VALID" || echo "INVALID"
[ "${TEMPTY+1}" ] && echo "VALID" || echo "INVALID"
[ "${TUNSET+1}" ] && echo "VALID" || echo "INVALID"

Я посвящаю этот ответ @ mklement0 (комментарии), который попросил меня ответить на вопрос точно.

Ссылка http://pubs.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#tag_18_06_02

15
Jarrod Chesney

Чтобы проверить, установлена ​​ли переменная с непустым значением, используйте [ -n "$x" ], как уже указали другие.

В большинстве случаев рекомендуется рассматривать переменную с пустым значением так же, как переменную, которая не установлена. Но вы можете различить два, если вам нужно: [ -n "${x+set}" ] ("${x+set}" расширяется до set, если x установлен, и до пустой строки, если x не установлено).

Чтобы проверить, был ли передан параметр, протестируйте $#, который представляет собой число параметров, переданных функции (или сценарию, когда отсутствует в функции) (см. ответ Павла ).

14
Gilles

Прочтите раздел "Расширение параметров" справочной страницы bash. Расширение параметра не обеспечивает общий тест для устанавливаемой переменной, но есть несколько вещей, которые вы можете сделать с параметром, если он не установлен.

Например:

function a {
    first_arg=${1-foo}
    # rest of the function
}

установит first_arg равным $1, если он назначен, в противном случае он использует значение "foo". Если a обязательно должен принимать один параметр, и не существует подходящего значения по умолчанию, вы можете выйти с сообщением об ошибке, если параметр не указан:

function a {
    : ${1?a must take a single argument}
    # rest of the function
}

(Обратите внимание на использование : в качестве пустой команды, которая просто расширяет значения ее аргументов. Мы не хотим ничего делать с $1 в этом примере, просто завершите работу, если она не установлена)

14
chepner

В bash вы можете использовать -v внутри встроенного [[ ]]:

#! /bin/bash -u

if [[ ! -v SOMEVAR ]]; then
    SOMEVAR='hello'
fi

echo $SOMEVAR
13
AlejandroVD

Для тех, кто ищет для проверки не установленное или пустое в сценарии с set -u :

if [ -z "${var-}" ]; then
   echo "Must provide var environment variable. Exiting...."
   exit 1
fi

Обычная проверка [ -z "$var" ] завершится с ошибкой var; unbound variable, если set -u, но [ -z "${var-}" ]раскрывает в пустую строку, если var сброшена без сбоя.

12
ecerulm

Заметка

Я даю в значительной степени Bash-ориентированный ответ из-за тега bash.

Короткий ответ

Пока вы имеете дело только с именованными переменными в Bash, эта функция всегда должна сообщать вам, установлена ​​ли переменная, даже если это пустой массив.

is-variable-set() {
    declare -p $1 &>dev/null
}

Почему это работает

В Bash (по крайней мере, начиная с версии 3.0), если var является объявленной/установленной переменной, тогда declare -p var выводит команду declare, которая установит переменную var, независимо от ее текущего типа и значения, и возвращает код состояния 0 (успех). Если var не объявлен, то declare -p var выводит сообщение об ошибке в stderr и возвращает код состояния 1. Используя &>/dev/null, перенаправляет как обычные выходные данные stdout, так и stderr в /dev/null, чтобы их никогда не видели, и без изменения кода состояния. Таким образом, функция возвращает только код состояния.

Почему другие методы (иногда) терпят неудачу в Bash

  • [ -n "$var" ]: Это только проверяет, является ли ${var[0]} непустым. (В Bash $var совпадает с ${var[0]}.)
  • [ -n "${var+x}" ]: Это только проверяет, установлен ли ${var[0]}.
  • [ "${#var[@]}" != 0 ]: Это только проверяет, установлен ли хотя бы один индекс $var.

Когда этот метод не работает в Bash

Это работает только для именованных переменных (в том числе $_), а не некоторые специальные переменные ($!, [email protected], $#, $$, $*, $?, $-, $0, $1, $2, ..., и любой я забыл). Поскольку ни один из них не является массивом, [ -n "${var+x}" ] в стиле POSIX работает для всех этих специальных переменных. Но остерегайтесь оборачивать его в функцию, так как многие специальные переменные изменяют значения/существование при вызове функций.

Примечание о совместимости оболочки

Если в вашем сценарии есть массивы, и вы пытаетесь сделать его совместимым с максимально возможным количеством оболочек, то рассмотрите возможность использования typeset -p вместо declare -p. Я читал, что ksh поддерживает только первое, но не смог проверить это. Я знаю, что Bash 3.0+ и Zsh 5.5.1 поддерживают оба typeset -p и declare -p, отличающиеся только тем, что одно является альтернативой для другого. Но я не проверял различия между этими двумя ключевыми словами и не проверял другие оболочки.

Если вам нужен ваш POSIX-совместимый скрипт, то вы не можете использовать массивы. Без массивов [ -n "{$var+x}" ] работает.

Код сравнения для разных методов в Bash

Эта функция сбрасывает переменную var, evals переданный код, запускает тесты, чтобы определить, установлено ли var с помощью кода evald, и, наконец, показывает результирующие коды состояния для различных тестов.

Я пропускаю test -v var, [ -v var ] и [[ -v var ]], потому что они дают результаты, идентичные стандарту POSIX [ -n "${var+x}" ], при этом требуется Bash 4.2+. Я также пропускаю typeset -p, потому что он совпадает с declare -p в оболочках, которые я тестировал (Bash 3.0 - 5.0 и Zsh 5.5.1).

is-var-set-after() {
    # Set var by passed expression.
    unset var
    eval "$1"

    # Run the tests, in increasing order of accuracy.
    [ -n "$var" ] # (index 0 of) var is nonempty
    nonempty=$?
    [ -n "${var+x}" ] # (index 0 of) var is set, maybe empty
    plus=$?
    [ "${#var[@]}" != 0 ] # var has at least one index set, maybe empty
    count=$?
    declare -p var &>/dev/null # var has been declared (any type)
    declared=$?

    # Show test results.
    printf '%30s: %2s %2s %2s %2s\n' "$1" $nonempty $plus $count $declared
}

Код теста

Обратите внимание, что результаты теста могут быть неожиданными из-за того, что Bash рассматривает индексы нечислового массива как "0", если переменная не была объявлена ​​как ассоциативный массив. Кроме того, ассоциативные массивы действительны только в Bash 4.0+.

# Header.
printf '%30s: %2s %2s %2s %2s\n' "test" '-n' '+x' '#@' '-p'
# First 5 tests: Equivalent to setting 'var=foo' because index 0 of an
# indexed array is also the nonindexed value, and non-numerical
# indices in an array not declared as associative are the same as
# index 0.
is-var-set-after "var=foo"                        #  0  0  0  0
is-var-set-after "var=(foo)"                      #  0  0  0  0
is-var-set-after "var=([0]=foo)"                  #  0  0  0  0
is-var-set-after "var=([x]=foo)"                  #  0  0  0  0
is-var-set-after "var=([y]=bar [x]=foo)"          #  0  0  0  0
# '[ -n "$var" ]' fails when var is empty.
is-var-set-after "var=''"                         #  1  0  0  0
is-var-set-after "var=([0]='')"                   #  1  0  0  0
# Indices other than 0 are not detected by '[ -n "$var" ]' or by
# '[ -n "${var+x}" ]'.
is-var-set-after "var=([1]='')"                   #  1  1  0  0
is-var-set-after "var=([1]=foo)"                  #  1  1  0  0
is-var-set-after "declare -A var; var=([x]=foo)"  #  1  1  0  0
# Empty arrays are only detected by 'declare -p'.
is-var-set-after "var=()"                         #  1  1  1  0
is-var-set-after "declare -a var"                 #  1  1  1  0
is-var-set-after "declare -A var"                 #  1  1  1  0
# If 'var' is unset, then it even fails the 'declare -p var' test.
is-var-set-after "unset var"                      #  1  1  1  1

Тестовый вывод

Мнемоника теста в строке заголовка соответствует [ -n "$var" ], [ -n "${var+x}" ], [ "${#var[@]}" != 0 ] и declare -p var соответственно.

                         test: -n +x #@ -p
                      var=foo:  0  0  0  0
                    var=(foo):  0  0  0  0
                var=([0]=foo):  0  0  0  0
                var=([x]=foo):  0  0  0  0
        var=([y]=bar [x]=foo):  0  0  0  0
                       var='':  1  0  0  0
                 var=([0]=''):  1  0  0  0
                 var=([1]=''):  1  1  0  0
                var=([1]=foo):  1  1  0  0
declare -A var; var=([x]=foo):  1  1  0  0
                       var=():  1  1  1  0
               declare -a var:  1  1  1  0
               declare -A var:  1  1  1  0
                    unset var:  1  1  1  1

Резюме

  • declare -p var &>/dev/null надежно (100%?) для тестирования именованных переменных в Bash, начиная с версии 3.0.
  • [ -n "${var+x}" ] надежен в ситуациях, совместимых с POSIX, но не может обрабатывать массивы.
  • Существуют другие тесты для проверки, является ли переменная непустой, и для проверки объявленных переменных в других оболочках. Но эти тесты не подходят ни для скриптов Bash, ни для POSIX.
9
Mark Haferkamp

Использование [[ -z "$var" ]] - это самый простой способ узнать, установлена ​​ли переменная или нет, но этот параметр -z не различает неустановленную переменную и переменную, для которой установлена ​​пустая строка:

$ set=''
$ [[ -z "$set" ]] && echo "Set" || echo "Unset" 
Unset
$ [[ -z "$unset" ]] && echo "Set" || echo "Unset"
Unset

Лучше проверить это в соответствии с типом переменной: переменная env, параметр или обычная переменная.

Для переменной env:

[[ $(env | grep "varname=" | wc -l) -eq 1 ]] && echo "Set" || echo "Unset"

Для параметра (например, чтобы проверить наличие параметра $5):

[[ $# -ge 5 ]] && echo "Set" || echo "Unset"

Для обычной переменной (используя вспомогательную функцию, чтобы сделать это элегантным способом):

function declare_var {
   declare -p "$1" &> /dev/null
}
declare_var "var_name" && echo "Set" || echo "Unset"

Заметки:

  • $#: показывает количество позиционных параметров.
  • declare -p: дает вам определение переменной, переданной в качестве параметра. Если он существует, возвращает 0, если нет, возвращает 1 и печатает сообщение об ошибке.
  • &> /dev/null: подавляет вывод из declare -p, не затрагивая его код возврата.
5
Peregring-lk

Ответы выше не работают, если включена опция Bash set -u. Кроме того, они не являются динамическими, например, как проверить, определяется ли переменная с именем "dummy"? Попробуй это:

is_var_defined()
{
    if [ $# -ne 1 ]
    then
        echo "Expected exactly one argument: variable name as string, e.g., 'my_var'"
        exit 1
    fi
    # Tricky.  Since Bash option 'set -u' may be enabled, we cannot directly test if a variable
    # is defined with this construct: [ ! -z "$var" ].  Instead, we must use default value
    # substitution with this construct: [ ! -z "${var:-}" ].  Normally, a default value follows the
    # operator ':-', but here we leave it blank for empty (null) string.  Finally, we need to
    # substitute the text from $1 as 'var'.  This is not allowed directly in Bash with this
    # construct: [ ! -z "${$1:-}" ].  We need to use indirection with eval operator.
    # Example: $1="var"
    # Expansion for eval operator: "[ ! -z \${$1:-} ]" -> "[ ! -z \${var:-} ]"
    # Code  execute: [ ! -z ${var:-} ]
    eval "[ ! -z \${$1:-} ]"
    return $?  # Pedantic.
}

Связано: В Bash как проверить, определена ли переменная в режиме "-u"

4
kevinarpe

Ты можешь сделать:

function a {
        if [ ! -z "$1" ]; then
                echo '$1 is set'
        fi
}
4
codaddict

Мой предпочтительный способ заключается в следующем:

$var=10
$if ! ${var+false};then echo "is set";else echo "NOT set";fi
is set
$unset var
$if ! ${var+false};then echo "is set";else echo "NOT set";fi
NOT set

Таким образом, в основном, если переменная установлена, она становится "отрицанием результирующего false" (что будет true = "установлено").

И, если он не установлен, он станет "отрицанием результирующего true" (так как пустой результат оценивается как true) (так что в конечном итоге это будет false = "NOT set").

1
Aquarius Power

В командной консоли вы можете использовать оператор -z, который имеет значение True, если длина строки равна нулю.

Простой однострочник для установки значения по умолчанию MY_VAR, если он не задан, в противном случае при желании вы можете отобразить сообщение:

[[ -z "$MY_VAR" ]] && MY_VAR="default"
[[ -z "$MY_VAR" ]] && MY_VAR="default" || echo "Variable already set."
1
kenorb

Это то, что я использую каждый день:

#
# Check if a variable is set
#   param1  name of the variable
#
function is_set()
{
    [[ -n "${1}" ]] && test -n "$(eval "echo "\${${1}+x}"")"
}

Это хорошо работает под Linux и Solaris вплоть до bash 3.0.

bash-3.00$ myvar="TEST"
bash-3.00$ is_set myvar ; echo $?
0
bash-3.00$ mavar=""
bash-3.00$ is_set myvar ; echo $?
0
bash-3.00$ unset myvar
bash-3.00$ is_set myvar ; echo $?
1
0
fr00tyl00p

После просмотра всех ответов это также работает:

if [[ -z $SOME_VAR ]]; then read -p "Enter a value for SOME_VAR: " SOME_VAR; fi
echo "SOME_VAR=$SOME_VAR"

если вы не поместите SOME_VAR вместо того, что у меня есть $SOME_VAR, он установит для него пустое значение; $ необходим для того, чтобы это работало.

0
Hatem Jaber

Я всегда использую это, основываясь на том факте, что его легко понять любому, кто видит код в первый раз:

if [ "$variable" = "" ]
    then
    echo "Variable X is empty"
fi

И, если хотите проверить, если не пусто;

if [ ! "$variable" = "" ]
    then
    echo "Variable X is not empty"
fi

Вот и все.

0
mijnnaam

Я нашел (намного) лучший код для этого, если вы хотите что-то проверить в [email protected].

 если [[$ 1 = ""]] 
, то 
 echo '$ 1 пусто' 
 else 
 echo '$ 1 заполнено' 
 фи 

Почему это все? Все в [email protected] существует в Bash, но по умолчанию оно пустое, поэтому test -z и test -n не могут вам помочь.

pdate: Вы также можете посчитать количество символов в параметрах.

 если [$ {# 1} = 0] 
, то 
 эхо "$ 1 пусто" 
 else 
 эхо "$ 1 заполнено" 
 фи 
0
Zlatan
if [[ ${!xx[@]} ]] ; then echo xx is defined; fi
0
Graham

Мне нравятся вспомогательные функции, чтобы скрыть грубые детали bash. В этом случае это добавляет еще больше (скрытой) грубости:

# The first ! negates the result (can't use -n to achieve this)
# the second ! expands the content of varname (can't do ${$varname})
function IsDeclared_Tricky
{
  local varname="$1"
  ! [ -z ${!varname+x} ]
}

Поскольку у меня сначала были ошибки в этой реализации (вдохновленные ответами Дженса и Лайонела), я придумал другое решение:

# Ask for the properties of the variable - fails if not declared
function IsDeclared()
{
  declare -p $1 &>/dev/null
}

Я нахожу это более прямым, более застенчивым и более простым для понимания/запоминания Тестовый пример показывает, что это эквивалентно:

function main()
{
  declare -i xyz
  local foo
  local bar=
  local baz=''

  IsDeclared_Tricky xyz; echo "IsDeclared_Tricky xyz: $?"
  IsDeclared_Tricky foo; echo "IsDeclared_Tricky foo: $?"
  IsDeclared_Tricky bar; echo "IsDeclared_Tricky bar: $?"
  IsDeclared_Tricky baz; echo "IsDeclared_Tricky baz: $?"

  IsDeclared xyz; echo "IsDeclared xyz: $?"
  IsDeclared foo; echo "IsDeclared foo: $?"
  IsDeclared bar; echo "IsDeclared bar: $?"
  IsDeclared baz; echo "IsDeclared baz: $?"
}

main

Тестовый пример также показывает, что local var делает НЕ объявляет var (если не следует '='). В течение достаточно долгого времени я думал, что я объявил переменные таким образом, просто чтобы обнаружить теперь, что я просто выразил свое намерение ... Я полагаю, что это неоперация.

IsDeclared_Tricky xyz: 1
IsDeclared_Tricky foo: 1
IsDeclared_Tricky bar: 0
IsDeclared_Tricky baz: 0
IsDeclared XYZ: 1
IsDeclared foo: 1
IsDeclared bar: 0
IsDeclared baz: 0

БОНУС: usecase

Я в основном использую этот тест для того, чтобы (или возвращать) параметры функциям несколько "элегантно" и безопасно (почти как интерфейс ...) :

#auxiliary functions
function die()
{
  echo "Error: $1"; exit 1
}

function assertVariableDeclared()
{
  IsDeclared "$1" || die "variable not declared: $1"
}

function expectVariables()
{
  while (( $# > 0 )); do
    assertVariableDeclared $1; shift
  done
}

# actual example
function exampleFunction()
{
  expectVariables inputStr outputStr
  outputStr="$inputStr world!"
}

function bonus()
{
  local inputStr='Hello'
  local outputStr= # remove this to trigger error
  exampleFunction
  echo $outputStr
}

bonus

Если вызывается со всеми, объявлены переменные:

Привет, мир!

еще:

Ошибка: переменная не объявлена: outputStr

0
Daniel S
if [[ ${1:+isset} ]]
then echo "It was set and not null." >&2
else echo "It was not set or it was null." >&2
fi

if [[ ${1+isset} ]]
then echo "It was set but might be null." >&2
else echo "It was was not set." >&2
fi
0
solidsnack
[[ $foo ]]

Или же

(( ${#foo} ))

Или же

let ${#foo}

Или же

declare -p foo
0
Steven Penny